{% block swag_guided_shopping_presentation_detail_cms_pages %}
    <sw-card
            class="swag-guided-shopping-presentation-detail-cms-pages"
            position-identifier="swag-guided-shopping-presentation-detail-cms-pages"
            :isLoading="isLoading"
            xmlns="http://www.w3.org/1999/html">
        <template #title>
            <div
                class="sw-card__title"
            >
                {{ $tc('swag-guided-shopping-presentation.detailBase.cardTitleCmsPages') }}
            </div>
            <a type="button"
                class="swag-guided-shopping-presentation-detail-cms-pages_preview_action_button"
                @click="openPreviewPresentation"
            >
                <span>{{ $tc('swag-guided-shopping-presentation.detailCmsPages.buttonPreviewPresentation') }}</span>
                <sw-icon name="regular-external-link-s" size="10" />
            </a>
        </template>
        <div class="sw-card__toolbar">
            <sw-card-filter :placeholder="$tc('swag-guided-shopping-presentation.detailAppointments.findLayouts')"
                    @sw-card-filter-term-change="onSearchTermChange"
                    class="input-filter">
                <template #filter>
                    {% block swag_guided_shopping_presentation_detail_cms_pages_action_buttons %}
                        <div class="action-buttons">
                                {% block sw_product_detail_actions_save %}
                                <sw-button
                                    v-tooltip="{
                                                    message: onEditPresentationStructure,
                                                    disabled: acl.can('cms.creator') && isSystemDefaultLanguage,
                                                    showOnDisabledElements: true
                                                }"
                                    class="swag-guided-shopping-presentation-detail-cms-pages__add-cms-page-action"
                                    @click="openInPageBuilder(null, null)"
                                    :disabled="!acl.can('cms.creator') || !isSystemDefaultLanguage || !acl.can('guided_shopping_presentation.editor')">
                                    {{ $tc('swag-guided-shopping-presentation.detailCmsPages.buttonAddNewLayout') }}
                                </sw-button>
                                {% endblock %}
                            <sw-button
                                    variant="ghost"
                                    v-tooltip="{
                                                    message: onEditPresentationStructure,
                                                    disabled: acl.can('cms_page:read') && isSystemDefaultLanguage,
                                                    showOnDisabledElements: true
                                                }"
                                    class="swag-guided-shopping-presentation-detail-cms-pages__add-cms-page-action"
                                    @click="selectExistingLayout()"
                                    :disabled="!acl.can('cms_page:read') || !isSystemDefaultLanguage || !acl.can('guided_shopping_presentation.editor')">
                                {{ $tc('swag-guided-shopping-presentation.detailCmsPages.buttonChooseCmsPage') }}
                            </sw-button>
                        </div>
                    {% endblock %}
                </template>
            </sw-card-filter>
        </div>

        {% block swag_guided_shopping_presentation_cms_page_assignment_option_grid %}
            <sw-data-grid
                    v-if="total"
                    class="cms-page-assignment guide-shopping-table"
                    :dataSource="presentation.cmsPages"
                    :key="isLoadingGrid"
                    :isLoading="isLoadingGrid"
                    :allowInlineEdit="true"
                    :columns="assignedCmsPageColumns"
                    :compactMode="false"
                    :showSettings="true"
                    :showSelection="false"
                    :searchResultIds="searchResultIds"
                    :enableCompactMode="false"
                    @inline-edit-save="onInlineEditSave"
                    @inline-edit-cancel="onCancelInlineEdit"
            >

                <template #actions="{ item }">
                    <sw-context-menu-item
                            :disabled="!acl.can('guided_shopping_presentation.editor')"
                            @click="openInPageBuilder(item.cmsPage.id)">
                        {{ $tc('global.default.edit') }}
                    </sw-context-menu-item>
                    <sw-context-menu-item
                            :disabled="!acl.can('guided_shopping_presentation.editor')"
                            @click="openLayoutTab(item.id)">
                        {{ $tc('swag-guided-shopping-presentation.detailCmsPages.openLayoutTab') }}
                    </sw-context-menu-item>
                    <sw-context-menu-item
                            v-if="item.slotConfig"
                            :disabled="!acl.can('guided_shopping_presentation.editor')"
                            @click="item.slotConfig = null">
                        {{ $tc('swag-guided-shopping-presentation.detailCmsPages.resetSlotConfig') }}
                    </sw-context-menu-item>

                    <sw-context-menu-item
                            :disabled="!acl.can('guided_shopping_presentation.editor')"
                            variant="danger"
                            @click="removeItem(item)">
                        {{ $tc('global.default.delete') }}
                    </sw-context-menu-item>
                </template>

                <template #column-title="{ item, isInlineEdit }">
                    <div class="content-wrapper" ref="searchResult">
                        <div class="title">
                            <template v-if="!isInlineEdit">
                                <a :href="$router.resolve({ name: 'sw.cms.detail', params: {id: item.cmsPage.id}}).href"
                                @click.prevent="openInPageBuilder(item.cmsPage.id)">
                                    {{ getTitle(item) }}
                                </a>
                            </template>
                            <template v-else>
                                <sw-text-field
                                        key="string"
                                        v-model:value="item.title"
                                        :placeholder="getTitle(item)"
                                />
                            </template>
                            <sw-circle-icon v-if="hasSlotConfig(item)"
                                iconName="regular-info-circle"
                                :size="contentOverwrittenIconSize"
                                variant="info"
                                v-tooltip="{
                                    message: $tc('swag-guided-shopping-presentation.detailCmsPages.contentOverwrittenHelpText'),
                                    width: 150
                                }"
                            />
                        </div>
                        <small class="layout-type-text">{{ pageTypes[item.cmsPage.type] }}</small>
                    </div>
                    <sw-button
                        class="override-content-button"
                        :disabled="!acl.can('guided_shopping_presentation.editor')"
                        @click="openLayoutTab(item.id)"
                        v-tooltip="{
                            message: $tc('swag-guided-shopping-presentation.detailCmsPages.overwriteContentHelpText'),
                            width: 150
                        }"
                    >
                        <sw-icon
                            name="regular-pencil-s"
                            size="13"
                        />
                    </sw-button>
                </template>

                <template #column-label-sections>
                    <p class="section-column-title">{{ $tc('swag-guided-shopping-presentation.detailCmsPages.columnSections') }}</p>
                    <sw-help-text :text="$tc('swag-guided-shopping-presentation.detailCmsPages.sectionsColumnHelpText')"/>
                </template>

                <template #column-sections="{ item }">
                    <span>
                        {{ item.cmsPage.sections.length }}
                    </span>
                </template>

                <template #column-position="{ item }">
                    <sw-data-grid-column-position
                            ref="columnPosition"
                            v-model="presentation.cmsPages"
                            :disabled="!acl.can('guided_shopping_presentation.editor')"
                            @position-changed="onChangePosition"
                            :item="item">
                    </sw-data-grid-column-position>
                </template>

                <template #column-data="{ item, isInlineEdit }">
                    <template v-if="item.cmsPage.type === 'presentation_product_detail'">

                        {% block swag_guided_shopping_product_detail_edit_select %}
                            <a class="sw-product-added" @click="onEditProductAssignment(item)">
                                <sw-entity-single-select
                                    :placeholder="!item.productId ? $tc('swag-guided-shopping-presentation.detailCmsPages.textProductAdd', 0) : ''"
                                    entity="product"
                                    :criteria="productCriteria"
                                    :repository="productRepository"
                                    class="products-select"
                                    v-model:value="item.productId"
                                    :disabled="true"
                                    size="small"
                                    :context="searchContext">
                                    <template #selection-label-property="{ item }">
                                        <sw-product-variant-info
                                            :variations="item.variation"
                                            :title-term="item.name"
                                            :media="item.cover ? item.cover.media : null"
                                        >
                                            {{ item.translated.name || item.name }}
                                        </sw-product-variant-info>
                                    </template>
                                </sw-entity-single-select>
                                <sw-icon
                                    name="regular-long-arrow-right"
                                    small
                                />
                            </a>
                        {% endblock %}
                    </template>
                    <template v-else-if="item.cmsPage.type === 'presentation_product_list'">
                        {% block swag_guided_shopping_product_list_display %}
                            <template v-if="item.productStreamId">
                                <a class="sw-product-added" @click="onEditProductAssignment(item)">
                                    <sw-entity-single-select
                                            :placeholder="$tc('swag-guided-shopping-presentation.detailCmsPages.productStreamSelect')"
                                            entity="product_stream"
                                            class="stream products-select"
                                            :value="item.productStreamId"
                                            v-model:value="item.productStreamId"
                                            :disabled="true"
                                            size="small"
                                            :context="searchContext">
                                    </sw-entity-single-select>
                                    <sw-icon
                                        name="regular-long-arrow-right"
                                        small
                                    />
                                </a>
                            </template>
                            <template v-else>
                                <a class="sw-product-added" @click="onEditProductAssignment(item)">
                                    {{$tc(item.pickedProductIds?.length === 1 ? 'swag-guided-shopping-presentation.detailCmsPages.textProductAdd' : 'swag-guided-shopping-presentation.detailCmsPages.textProductsAdd', item.pickedProductIds?.length ?? 0)}}
                                    <sw-icon
                                        name="regular-long-arrow-right"
                                        small
                                    />
                                </a>
                            </template>
                        {% endblock %}
                    </template>
                    <template v-else>
                        <span>-</span>
                    </template>
                </template>
            </sw-data-grid>
        {% endblock %}

        {% block swag_guided_shopping_presentation_product_assignment_modal %}
            <sw-modal v-if="currentCmsPageRelation"
                      class="sw-modal-product-assignment"
                      variant="large"
                      @modal-close="onCloseCmsModal"
                      :title="!isPDP ? $tc('swag-guided-shopping-presentation.detailCmsPages.modalTitleProducts') : $tc('swag-guided-shopping-presentation.detailCmsPages.modalTitleProduct')">

                {% block swag_guided_shopping_presentation_product_assignment_modal_appointment_form %}
                    <swag-guided-shopping-presentation-product-assignment
                            :entity="currentCmsPageRelation"
                            :pickedProducts="currentCmsPageRelation.products"
                            :isLoading="isLoading"
                            :isModal="true"
                            v-if="!isPDP"
                    >

                    </swag-guided-shopping-presentation-product-assignment>
                    <div class="swag-guided-shopping-product-assignment" v-else>
                        <sw-card
                            class="sw-many-to-many-assignment-card"
                            position-identifier="sw-many-to-many-assignment-card"
                            v-bind="$attrs"
                        >
                            <sw-entity-single-select
                                v-model:value="pdpId"
                                class="swag-guided-shopping-product-assignment__product-assignment-type-select"
                                entity="product"
                                :label="$tc('swag-guided-shopping-presentation.detailCmsPages.productSelect')"
                                :placeholder="$tc('sw-category.base.products.productAssignmentPlaceholder')"
                                :disabled="!acl.can('entity.editor')"
                                required
                                :criteria="productCriteria"
                                :context="searchContext"
                                :repository="productRepository"
                            >
                                <template #selection-label-property="{ item }">
                                    <sw-product-variant-info
                                            :variations="item.variation"
                                            :media="item.cover ? item.cover.media : null"
                                    >
                                        {{ item.translated.name || item.name }}
                                    </sw-product-variant-info>
                                </template>
                                <template #result-label-property="{ item }">
                                    <sw-product-variant-info
                                            :variations="item.variation"
                                            :media="item.cover ? item.cover.media : null"
                                    >
                                        {{ item.translated.name || item.name }}
                                    </sw-product-variant-info>
                                </template>
                            </sw-entity-single-select>
                        </sw-card>
                    </div>
                {% endblock %}


                {% block swag_guided_shopping_presentation_product_assignment_modal_footer %}
                    <template #modal-footer>
                        {% block swag_guided_shopping_presentation_product_assignment_modal_cancel %}
                            <sw-button size="small" @click="onCloseCmsModal">
                                {{ $tc('swag-guided-shopping-presentation.detailCmsPages.buttonCancel') }}
                            </sw-button>
                        {% endblock %}

                        {% block swag_guided_shopping_presentation_product_assignment_modal_apply %}
                            <sw-button variant="primary" size="small" @click="onSaveProductModal">
                                {{ $tc('swag-guided-shopping-presentation.detailCmsPages.buttonApply') }}
                            </sw-button>
                        {% endblock %}
                    </template>
                {% endblock %}
            </sw-modal>
        {% endblock %}

        {% block swag_guided_shopping_presentation_cms_page_assignment_empty_state %}
            <sw-empty-state
                    v-if="!total && !isLoadingGrid"
                    class="swag-guided-shopping-presentation-cms-pages-assignment__option-list-empty-state"
                    title=""
                    :absolute="false"
                    :subline="$tc('swag-guided-shopping-presentation.base.cmsPage.assignEmptyStateDescription')">
                <template #icon>
                    <img :src="'/swagguidedshopping/static/img/empty-states/layouts-empty-state.svg' | asset">
                </template>
            </sw-empty-state>
        {% endblock %}

        {% block sw_category_entry_point_card_configure_home_modal %}
            <sw-cms-layout-modal
                ref="cmsLayoutModal"
                v-if="showLayoutSelectionModal"
                :cms-page-types="pageTypesFlat"
                :headline="$tc('swag-guided-shopping-presentation.detailCmsPages.buttonChooseCmsPage')"
                :multipleSelect="true"
                :allowDelete="true"
                @modal-layout-select="onToggleCmsPage"
                @bulk-delete-confirm="onOpenBulkDeleteConfirmModal"
                @modal-close="closeLayoutModal"
            />
        {% endblock %}

        <sw-modal
            v-if="showBulkDeleteConfirmModal"
            :title="$tc('global.default.warning')"
            variant="small"
            @modal-close="onCloseBulkDeleteConfirmModal"
        >
            <div class="sw_tree__confirm-delete-text">
                {{ $tc('swag-guided-shopping-presentation.modal.textBulkDeleteElementsConfirm', 0, { count: bulkDeleteElements.length }) }}
            </div>

            <template #modal-footer>
                <sw-button
                    size="small"
                    @click="onCloseBulkDeleteConfirmModal"
                >
                    {{ $tc('sw-cms.components.cmsListItem.modal.buttonCancel') }}
                </sw-button>

                <sw-button
                    variant="danger"
                    size="small"
                    @click="onConfirmBulkDelete"
                >
                    {{ $tc('sw-cms.components.cmsListItem.modal.buttonDelete') }}
                </sw-button>
            </template>
        </sw-modal>

        {% block swag_guided_shopping_presentation_detail_cms_pages_load_preview_presentation %}
            <sw-loader
                v-if="isLoadingPreviewPresentation"
                class="swag-guided-shopping-presentation-detail-cms-pages__load-preview-presentation">
            </sw-loader>
        {% endblock %}
    </sw-card>
{% endblock %}
